/**
 * Copyright (C) 2010-2012 Agrosense info@agrosense.eu
 *
 * Licensed under the Eclipse Public License - v 1.0 (the "License"); you may
 * not use this file except in compliance with the License. You may obtain a
 * copy of the License at
 *
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
package nl.cloudfarming.client.fleet.machine.wizard;

import java.beans.PropertyEditor;
import javax.swing.JLabel;
import javax.swing.JPanel;
import net.miginfocom.swing.MigLayout;
import org.openide.explorer.propertysheet.PropertyPanel;
import org.openide.nodes.Node.Property;
import org.openide.util.NbBundle;

/**
 * The visual overview for the machine wizard. The values to show on this panel
 * can be dynamically added.
 *
 * @author Wytse Visser
 */
@NbBundle.Messages({"overviewStepName=Overview"})
class MachineVisualOverviewPanel extends JPanel {

    /**
     * Creates new form MachineVisualOverviewPanel
     */
    public MachineVisualOverviewPanel() {
        setLayout(new MigLayout("wrap 2"));
    }

    public void addProperty(String name, Object value) {
        add(new JLabel(name));
        if (value != null) {
            add(new JLabel(value.toString()));
        } else{
            add(new JLabel());
        }
    }

    void addProperty(Property property) {
        PropertyPanel propertyPanel = new PropertyPanel(property);
        PropertyEditor propertyEditor = propertyPanel.getPropertyEditor(); // FIXME: Calling a deprecated method. Is there another way?
        addProperty(property.getDisplayName(), propertyEditor.getAsText());
    }

    @Override
    public String getName() {
        return Bundle.overviewStepName();
    }
}